Use the ->possible states and remove the merge_hook().
[smatch.git] / validation / test-suite
blob1a35703070f4911817e714011c87ffbcde70b069
1 #!/bin/sh
3 #set -x
5 default_path=".."
6 default_cmd="sparse \$file"
7 tests_list=`find . -name '*.c' | sed -e 's#^\./\(.*\)#\1#' | sort`
8 prog_name=`basename $0`
10 # counts:
11 # - tests that have not been converted to test-suite format
12 # - tests that passed
13 # - tests that failed
14 # - tests that failed but are known to fail
15 unhandled_tests=0
16 ok_tests=0
17 ko_tests=0
18 known_ko_tests=0
20 # defaults to not verbose
21 [ -z "$V" ] && V=0
24 # get_value(key, file) - gets the value of a (key, value) pair in file.
26 # returns 0 on success, 1 if the file does not have the key
27 get_value()
29 last_result=`grep $1: $2 | sed -e "s/^.*$1:\(.*\)$/\1/"`
30 [ -z "$last_result" ] && return 1
31 return 0
35 # get_tag(key, file) - does file has the tag key in it ?
37 # returns 0 if present, 1 otherwise
38 get_tag()
40 last_result=`grep $1 $2`
41 return $?
45 # verbose(string) - prints string if we are in verbose mode
46 verbose()
48 [ "$V" -eq "1" ] && echo " $1"
49 return 0
53 # error(string[, die]) - prints an error and exits with value die if given
54 error()
56 echo "error: $1"
57 [ -n "$2" ] && exit $2
58 return 0
61 do_usage()
63 echo "$prog_name - a tiny automatic testing script"
64 echo "Usage: $prog_name [command] [command arguments]"
65 echo
66 echo "commands:"
67 echo " none runs the whole test suite"
68 echo " single file runs the test in 'file'"
69 echo " format file [name [cmd]] helps writing a new test case using cmd"
70 echo
71 echo " help prints usage"
75 # do_test(file) - tries to validate a test case
77 # it "parses" file, looking for check-* tags and tries to validate
78 # the test against an expected result
79 # returns:
80 # - 0 if the test passed,
81 # - 1 if it failed,
82 # - 2 if it is not a "test-suite" test.
83 do_test()
85 test_failed=0
86 file="$1"
88 # can this test be handled by test-suite ?
89 # (it has to have a check-name key in it)
90 get_value "check-name" $file
91 if [ "$?" -eq 1 ]; then
92 unhandled_tests=`expr $unhandled_tests + 1`
93 return 2
95 test_name=$last_result
97 echo " TEST $test_name ($file)"
99 # does the test provide a specific command ?
100 cmd=`eval echo $default_path/$default_cmd`
101 get_value "check-command" $file
102 if [ "$?" -eq "0" ]; then
103 last_result=`echo $last_result | sed -e 's/^ *//'`
104 cmd=`eval echo $default_path/$last_result`
106 verbose "Using command : $cmd"
108 # grab the expected exit value
109 get_value "check-exit-value" $file
110 if [ "$?" -eq "0" ]; then
111 expected_exit_value=`echo $last_result | tr -d ' '`
112 else
113 expected_exit_value=0
115 verbose "Expecting exit value: $expected_exit_value"
117 # grab the expected output
118 sed -n '/check-output-start/,/check-output-end/p' $file \
119 | grep -v check-output > "$file".output.expected
120 sed -n '/check-error-start/,/check-error-end/p' $file \
121 | grep -v check-error > "$file".error.expected
123 # grab the actual output & exit value
124 $cmd 1> $file.output.got 2> $file.error.got
125 actual_exit_value=$?
127 for stream in output error; do
128 diff -u "$file".$stream.expected "$file".$stream.got > "$file".$stream.diff
129 if [ "$?" -ne "0" ]; then
130 error "actual $stream text does not match expected $stream text."
131 error "see $file.$stream.* for further investigation."
132 test_failed=1
134 done
136 if [ "$actual_exit_value" -ne "$expected_exit_value" ]; then
137 error "Actual exit value does not match the expected one."
138 error "expected $expected_exit_value, got $actual_exit_value."
139 test_failed=1
142 if [ "$test_failed" -eq "1" ]; then
143 ko_tests=`expr $ko_tests + 1`
144 get_tag "check-known-to-fail" $file
145 [ "$?" -eq "0" ] && known_ko_tests=`expr $known_ko_tests + 1`
146 return 1
147 else
148 ok_tests=`expr $ok_tests + 1`
149 return 0
153 do_test_suite()
155 for i in $tests_list; do
156 do_test "$i"
157 done
159 # prints some numbers
160 tests_nr=`expr $ok_tests + $ko_tests`
161 echo -n "Out of $tests_nr tests, $ok_tests passed, $ko_tests failed"
162 echo " ($known_ko_tests of them are known to fail)"
163 if [ "$unhandled_tests" -ne "0" ]; then
164 echo "$unhandled_tests tests could not be handled by $prog_name"
169 # do_format(file[, name[, cmd]]) - helps a test writer to format test-suite tags
170 do_format()
172 if [ -z "$2" ]; then
173 fname="$1"
174 fcmd=$default_cmd
175 elif [ -z "$3" ]; then
176 fname="$2"
177 fcmd=$default_cmd
178 else
179 fname="$2"
180 fcmd="$3"
182 file="$1"
183 cmd=`eval echo $default_path/$fcmd`
184 $cmd 1> $file.output.got 2> $file.error.got
185 fexit_value=$?
186 cat <<_EOF
188 * check-name: $fname
189 _EOF
190 if [ "$fcmd" != "$default_cmd" ]; then
191 echo " * check-command: $fcmd"
193 if [ "$fexit_value" -ne "0" ]; then
194 echo " * check-exit-value: $fexit_value"
196 for stream in output error; do
197 if [ -s "$file.$stream.got" ]; then
198 echo " *"
199 echo " * check-$stream-start"
200 cat "$file.$stream.got"
201 echo " * check-$stream-end"
203 done
204 echo " */"
205 return 0
209 # arg_file(filename) - checks if filename exists
210 arg_file()
212 [ -z "$1" ] && {
213 do_usage
214 exit 1
216 [ -e "$1" ] || {
217 error "Can't open file $1"
218 exit 1
220 return 0
223 case "$1" in
225 do_test_suite
227 single)
228 arg_file "$2"
229 do_test "$2"
230 case "$?" in
231 0) echo "$2 passed !";;
232 1) echo "$2 failed !";;
233 2) echo "$2 can't be handled by $prog_name";;
234 esac
236 format)
237 arg_file "$2"
238 do_format "$2" "$3" "$4"
240 help | *)
241 do_usage
242 exit 1
244 esac
246 exit 0